<?php namespace App\Services;

use App\DAO\DAOResponse\DAOResponseInterface;
use App\DAO\Filter\QueryFilter;
use App\DAO\Pagination\Pagination;
use App\DAO\GaleriaClassificacaoDAO;
use App\Entities\GaleriaClassificacao\GaleriaClassificacao;
use App\Mappers\GaleriaClassificacaoMapper;
use App\Services\ServiceResponse\ServiceResponse;
use App\Services\ServiceResponse\ServiceResponseInterface;
use App\Utils\Collections\QueryFilterCollection;
use App\Utils\Collections\QueryOrderCollection;
use CodeIgniter\Model;

class GaleriaClassificacaoService extends Service
{
    public function registerGaleriaClassificacao (array $data_request) : ServiceResponse {
        $exame_registration_vm = GaleriaClassificacaoMapper::getGaleriaClassificacaoRegistrationVMFromArray($data_request);
        $exame_dao = new GaleriaClassificacaoDAO();
        $dao_response = $exame_dao->persistGaleriaClassificacaoRegistrationVM($exame_registration_vm);
        $service_response = new ServiceResponse();
        switch ($dao_response->getStatus()) {
            case DAOResponseInterface::SUCESS:
                $data = [
                    'id_classificacao' => $dao_response->getData()->getId()
                ];
                $service_response->setStatus(ServiceResponseInterface::SUCESS);
                $service_response->setData($data);
                break;
            case DAOResponseInterface::FOREIGN_KEY_DONT_EXISTS:
            case DAOResponseInterface::DUPLICATED_UNIQUE_KEY:
                $service_response->setStatus(ServiceResponseInterface::VALIDATION_PARAMS_ERROR);
                $service_response->setErrors($dao_response->getErrors());
                break;
            case DAOResponseInterface::DATABASE_CONNECTION_ERROR:
                $service_response->setStatus(ServiceResponseInterface::DATABASE_CONNECTION_ERROR);
                break;
        }
        return $service_response;
    }

    public function getGaleriaClassificacaoList (?Pagination $pagination, ?QueryFilterCollection $query_filter_collection, ?QueryOrderCollection $query_order_collection) : ServiceResponse{
        $exame_dao = new GaleriaClassificacaoDAO();
        $dao_response = $exame_dao->getGaleriaClassificacaoList($pagination, $query_filter_collection, $query_order_collection);
        switch ($dao_response->getStatus()) {
            case DAOResponseInterface::SUCESS:
                $service_response_status = ServiceResponseInterface::SUCESS;
                break;
            case DAOResponseInterface::RECORD_NOT_FOUND:
                $service_response_status = ServiceResponseInterface::RECORD_NOT_FOUND;
                break;
            case DAOResponseInterface::DATABASE_CONNECTION_ERROR:
                $service_response_status = ServiceResponseInterface::DATABASE_CONNECTION_ERROR;
                break;
        }
        $service_response = ServiceResponse::builder()
            ->setStatus($service_response_status)
            ->build();
        if ($service_response_status === DAOResponseInterface::SUCESS) {
            $dao_response_data = $dao_response->getData();
            $exame_details_array = GaleriaClassificacaoMapper::getGaleriaClassificacaosDetailsArrayFromGaleriaClassificacaoDetailsVMCollection($dao_response_data);
            $pagination = $dao_response->getPagination();
            $data = [
                'classificacao' => $exame_details_array,
                'pagination' => $pagination ? $pagination->toResponseArray() : null
            ];
            $service_response->setData($data);
        }
        return $service_response;
    }

    public function getGaleriaClassificacao (QueryFilter $query_filter) : ServiceResponse {
        $exame_dao = new GaleriaClassificacaoDAO();
        $query_filter_collection = new QueryFilterCollection();
        $query_filter_collection->push($query_filter);
        $dao_response = $exame_dao->getGaleriaClassificacao($query_filter_collection);
        $service_response_status = [
            DAOResponseInterface::SUCESS => ServiceResponseInterface::SUCESS,
            DAOResponseInterface::RECORD_NOT_FOUND => ServiceResponseInterface::RECORD_NOT_FOUND,
            DAOResponseInterface::DATABASE_CONNECTION_ERROR => ServiceResponseInterface::DATABASE_CONNECTION_ERROR,
        ][$dao_response->getStatus()];
        $service_response = ServiceResponse::builder()
            ->setStatus($service_response_status ?? ServiceResponseInterface::UNKNOWN_ERROR)
            ->build();
        if ($service_response_status === ServiceResponseInterface::SUCESS) {
            $service_response->setData($dao_response->getData()->toArray());
        }
        return $service_response;
    }

    public function deleteGaleriaClassificacao (int $id_exame) : ServiceResponse{
        $exame_dao = new GaleriaClassificacaoDAO();
        $dao_response = $exame_dao->deleteGaleriaClassificacao($id_exame);
        $service_response_status = [
            DAOResponseInterface::RESTRICT_FK_UPDATE_OR_DELETION => ServiceResponseInterface::RECORD_IS_LINKED,
            DAOResponseInterface::SUCESS => ServiceResponseInterface::SUCESS,
            DAOResponseInterface::RECORD_NOT_FOUND => ServiceResponseInterface::RECORD_NOT_FOUND,
        ][$dao_response->getStatus()];

        $service_response = ServiceResponse::builder()
            ->setStatus($service_response_status)
            ->build();
        return $service_response;
    }

    public function updateGaleriaClassificacaoData (int $id_paciente, array $data) : ServiceResponse {
        $paciente_update_vm = GaleriaClassificacaoMapper::getGaleriaClassificacaoUpdateVMFromArray($data);
        $paciente_dao = new GaleriaClassificacaoDAO();
        $dao_response = $paciente_dao->persistGaleriaClassificacaoUpdateVM($id_paciente, $paciente_update_vm);
        $service_response = new ServiceResponse;
        $response_status = [
            DAOResponseInterface::SUCESS => ServiceResponseInterface::SUCESS,
            DAOResponseInterface::RECORD_NOT_FOUND => ServiceResponseInterface::RECORD_NOT_FOUND,
            DAOResponseInterface::DATABASE_CONNECTION_ERROR => ServiceResponseInterface::DATABASE_CONNECTION_ERROR,
            DAOResponseInterface::FOREIGN_KEY_DONT_EXISTS => ServiceResponseInterface::VALIDATION_PARAMS_ERROR,
            DAOResponseInterface::DUPLICATED_UNIQUE_KEY => ServiceResponseInterface::VALIDATION_PARAMS_ERROR,
        ][$dao_response->getStatus()];
        if (!$response_status) {
            (new LogService)->log_error($response_status, "Ocorreu um erro desconhecido durante a atualização o exame", []);
            $response_status = ServiceResponseInterface::DATABASE_CONNECTION_ERROR;
        } else if ($response_status !== ServiceResponseInterface::SUCESS) {
            $service_response->setErrors($dao_response->getErrors());
        }
        $service_response->setStatus($response_status);
        return $service_response;
    }
}